// Quick test of reading entire directory

#include "log.h"
#include "cpmio.h"
#include <string.h>

FCB fcb;
DIRENT dir[4];

int main (void)
    {
    log_open ();
    DPB *pdpb = bdos_disk_parameters ();
    log_str ("sectors = ");
    log_uint (pdpb->sectors);
    log_str ("\r\nblock_shift = ");
    log_uint (pdpb->block_shift);
    log_str ("\r\nblock_mask = ");
    log_byte (pdpb->block_mask);
    log_str ("\r\nextent_mask = ");
    log_byte (pdpb->extent_mask);
    log_str ("\r\nalloc_max = ");
    log_uint (pdpb->alloc_max);
    log_str ("\r\nalloc_max = ");
    log_uint (pdpb->dir_max);
    log_str ("\r\ndir_alloc = ");
    log_byte (pdpb->dir_alloc[0]);
    log_byte (pdpb->dir_alloc[1]);
    log_str ("\r\ndir_check = ");
    log_uint (pdpb->dir_check);
    log_str ("\r\noffset = ");
    log_uint (pdpb->offset);
    log_str ("\r\n");
    strcpy (&fcb.drive, "????????????");
    bdos_set_dma_address (dir);
    int idx = bdos_search_for_first (&fcb);
    while ( idx < 4 )
        {
        /*
        log_uint (idx);
        for (int i = 0; i < 4; ++i)
            {
            log_str (" ");
            if ( dir[i].drive == 0xE5 )
                {
                log_str ("Empty dir     ");
                }
            else
                {
                dir[i].drive += '0';
                log_strn (&dir[i].drive, 12);
                log_str (" ");
                log_uint (dir[i].ex);
                }
            }
        log_str ("\r\n");
        */
        DIRENT *pdir = &dir[idx];
        if ( pdir->drive != 0xE5 )
            {
            log_strn (pdir->filename, 11);
            log_str (" ");
            log_byte (pdir->ex);
            log_str (" ");
            log_byte (pdir->s1);
            log_str (" ");
            log_byte (pdir->s2);
            log_str (" ");
            log_byte (pdir->rc);
            for (int i = 0; i < 8; ++i)
                {
                log_str (" ");
                log_word (pdir->alw[i]);
                }
            log_str ("\r\n");
            }
        idx = bdos_search_for_next (&fcb);
        }
    }
