;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.0.0 #11528 (Linux)
;--------------------------------------------------------
	.module fiber
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _fiber_show
	.globl _log_word
	.globl _log_printf
	.globl _list_remove_item
	.globl _list_remove_first
	.globl _list_add_last
	.globl _list_next
	.globl _list_first
	.globl _list_init
	.globl _fiber_init
	.globl _fiber_enqueue
	.globl _fiber_dequeue
	.globl _fiber_drain
	.globl _fiber_enqueue_isr
	.globl _fiber_drain_isr
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
_fiber_list:
	.ds 4
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
_fiber_draining:
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;fiber.c:25: void fiber_init(void)
;	---------------------------------
; Function fiber_init
; ---------------------------------
_fiber_init::
;fiber.c:27: list_init(&fiber_list);
	ld	hl, #_fiber_list
	push	hl
	call	_list_init
	pop	af
;fiber.c:28: }
	ret
;fiber.c:30: void fiber_show(void)
;	---------------------------------
; Function fiber_show
; ---------------------------------
_fiber_show::
;fiber.c:32: FIBER *f = list_first(&fiber_list);
	ld	hl, #_fiber_list
	push	hl
	call	_list_first
	pop	af
	ld	c, l
	ld	b, h
;fiber.c:33: while (f)
00101$:
	ld	a, b
	or	a, c
	ret	Z
;fiber.c:35: log_printf ("f = $");
	push	bc
	ld	hl, #___str_0
	push	hl
	call	_log_printf
	pop	af
	pop	bc
;fiber.c:36: log_word ((word) f);
	ld	e, c
	ld	d, b
	push	bc
	push	de
	call	_log_word
	ld	hl, #___str_1
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	bc
;fiber.c:38: log_word ((word) f->nf);
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	call	_log_word
	ld	hl, #___str_2
	ex	(sp),hl
	call	_log_printf
	pop	af
	pop	bc
;fiber.c:40: log_word ((word) f->nfp);
	ld	l, c
	ld	h, b
	ld	de, #0x0004
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	push	bc
	push	de
	call	_log_word
	ld	hl, #___str_3
	ex	(sp),hl
	call	_log_printf
	pop	af
	call	_list_next
	pop	af
	ld	c, l
	ld	b, h
;fiber.c:44: }
	jr	00101$
___str_0:
	.ascii "f = $"
	.db 0x00
___str_1:
	.ascii ", nf = $"
	.db 0x00
___str_2:
	.ascii ", nfp = $"
	.db 0x00
___str_3:
	.db 0x0d
	.db 0x0a
	.ascii "$"
	.db 0x00
;fiber.c:46: void fiber_enqueue(FIBER *f)
;	---------------------------------
; Function fiber_enqueue
; ---------------------------------
_fiber_enqueue::
	push	ix
	ld	ix,#0
	add	ix,sp
;fiber.c:51: if ( ! f->queued )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0006
	add	hl, bc
	ld	a, (hl)
	or	a, a
	jr	NZ,00105$
;fiber.c:54: f->queued = 1;
	ld	(hl), #0x01
;fiber.c:55: list_add_last(&fiber_list, f);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	ld	hl, #_fiber_list
	push	hl
	call	_list_add_last
	pop	af
	pop	af
;fiber.c:59: interrupts_enable();
00105$:
;fiber.c:68: }
	pop	ix
	ret
;fiber.c:70: void fiber_dequeue(FIBER *f)
;	---------------------------------
; Function fiber_dequeue
; ---------------------------------
_fiber_dequeue::
	push	ix
	ld	ix,#0
	add	ix,sp
;fiber.c:75: if ( f->queued )
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	ld	hl, #0x0006
	add	hl, bc
	ld	a, (hl)
	or	a, a
	jr	Z,00105$
;fiber.c:78: f->queued = 0;
	ld	(hl), #0x00
;fiber.c:86: list_remove_item(&fiber_list, f);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	ld	hl, #_fiber_list
	push	hl
	call	_list_remove_item
	pop	af
	pop	af
;fiber.c:88: fiber_show();
	call	_fiber_show
;fiber.c:89: interrupts_enable();
00105$:
;fiber.c:98: }
	pop	ix
	ret
;fiber.c:101: static void fiber_drainer(void)
;	---------------------------------
; Function fiber_drainer
; ---------------------------------
_fiber_drainer:
;fiber.c:104: fiber_draining = TRUE;
	ld	hl, #0x0001
	ld	(_fiber_draining), hl
;fiber.c:106: if ( (f = list_remove_first(&fiber_list)) != NULL )
	ld	hl, #_fiber_list
	push	hl
	call	_list_remove_first
	pop	af
	ld	c, l
	ld	a,h
	ld	b,a
	or	a, l
	jr	Z,00102$
;fiber.c:117: f->queued = 0;
	ld	hl, #0x0006
	add	hl, bc
	ld	(hl), #0x00
;fiber.c:118: f->nf(f->nfp);
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	l, c
	ld	h, b
	ld	bc, #0x0004
	add	hl, bc
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	push	bc
	ex	de,hl
	call	___sdcc_call_hl
	pop	af
;fiber.c:119: interrupts_disable();
00102$:
;fiber.c:121: fiber_draining = FALSE;
	ld	hl, #0x0000
	ld	(_fiber_draining), hl
;fiber.c:122: }
	ret
;fiber.c:125: void fiber_drain(void)
;	---------------------------------
; Function fiber_drain
; ---------------------------------
_fiber_drain::
;fiber.c:128: fiber_drainer();
;fiber.c:129: interrupts_enable();
;fiber.c:130: }
	jp	_fiber_drainer
;fiber.c:133: void fiber_enqueue_isr(FIBER *f)
;	---------------------------------
; Function fiber_enqueue_isr
; ---------------------------------
_fiber_enqueue_isr::
	push	ix
	ld	ix,#0
	add	ix,sp
;fiber.c:135: list_add_last(&fiber_list, f);
	ld	c, 4 (ix)
	ld	b, 5 (ix)
	push	bc
	ld	hl, #_fiber_list
	push	hl
	call	_list_add_last
	pop	af
	pop	af
;fiber.c:136: }
	pop	ix
	ret
;fiber.c:139: void fiber_drain_isr(void)
;	---------------------------------
; Function fiber_drain_isr
; ---------------------------------
_fiber_drain_isr::
;fiber.c:141: if ( !fiber_draining )
	ld	iy, #_fiber_draining
	ld	a, 1 (iy)
	or	a, 0 (iy)
;fiber.c:142: fiber_drainer();
	jp	Z,_fiber_drainer
;fiber.c:143: }
	ret
	.area _CODE
	.area _INITIALIZER
__xinit__fiber_draining:
	.dw #0x0000
	.area _CABS (ABS)
